--- a/cmdline/apt-get.cc
+++ b/cmdline/apt-get.cc
@@ -161,7 +161,7 @@ static std::string MetaIndexFileNameOnDisk(metaIndex *metaindex)
 // ---------------------------------------------------------------------
 /* */
 static std::string GetReleaseForSourceRecord(pkgSourceList *SrcList,
-                                      pkgSrcRecords::Parser *Parse)
+                                      pkgSrcRecords::Parser *Parse, std::string &Dist)
 {
    // try to find release
    const pkgIndexFile& CurrentIndexFile = Parse->Index();
@@ -184,6 +184,7 @@ static std::string GetReleaseForSourceRecord(pkgSourceList *SrcList,
             {
                indexRecords records;
                records.Load(path);
+               Dist = records.GetDist();
                return records.GetSuite();
             }
          }
@@ -387,13 +388,15 @@ static pkgSrcRecords::Parser *FindSrc(const char *Name,pkgRecords &Recs,
          // See if we need to look for a specific release tag
          if (RelTag != "" && UserRequestedVerTag == "")
          {
-            const string Rel = GetReleaseForSourceRecord(SrcList, Parse);
+            string Dist;
+            const string Rel = GetReleaseForSourceRecord(SrcList, Parse, Dist);
 
-            if (Rel == RelTag)
+            if (Rel == RelTag || Dist == RelTag)
             {
                Last = Parse;
                Offset = Parse->Offset();
                Version = Ver;
+               break;
             }
          }
 
